NeuralEngine A Game Engine with embeded Machine Learning algorithms based on Gaussian Processes. |

Public Member Functions | Protected Member Functions | Protected Attributes | Private Member Functions | Friends | List of all members
NeuralEngine::MachineLearning::ILayer< Scalar > Class Template Referenceabstract

Abstract class for different kind of layers. More...

`#include <FgILayer.h>`

Inheritance diagram for NeuralEngine::MachineLearning::ILayer< Scalar >:
[legend]
Collaboration diagram for NeuralEngine::MachineLearning::ILayer< Scalar >:
[legend]

## Public Member Functions
| ILayer (LayerType type, int numPoints, int outputDim)
| Constructor. More...
virtual | ~ILayer ()=default
| Destructor. More...
LayerType | GetType ()
| Gets the layer type. More...
virtual int | GetNumParameters ()=0
| Gets number of parameters to be optimized. More...
virtual void | SetParameters (const af::array &param)=0
| Sets the parameters for each optimization iteration. More...
virtual af::array | GetParameters ()=0
| Gets the parameters for each optimization iteration. More...
virtual void | UpdateParameters ()=0
| Updates the parameters. More...
virtual void | SetDataSize (int length, int dimension)
| Sets data size. More...

## Protected Member Functions
| ILayer ()
| Default constructor. More...

## Protected Attributes
int | iD
| data dimension More...
int | iN
| data size More...
LayerType | lType
| liklihood or gp layer More...
af::dtype | m_dType
| floating point precision flag for af::array More...

## Private Member Functions
template<class Archive >
void | serialize (Archive &ar, unsigned int version)

## Friends
class | boost::serialization::access

## Detailed Description

template<typename Scalar>
class NeuralEngine::MachineLearning::ILayer< Scalar >

Abstract class for different kind of layers.

, 27.02.2018.

Definition at line 37 of file FgILayer.h.

## Constructor & Destructor Documentation

## ◆ ILayer() [1/2]

template<typename Scalar >

NeuralEngine::MachineLearning::ILayer< Scalar >::ILayer | ( | LayerType | type,
|  | int | numPoints,
|  | int | outputDim
| ) |  |
| inline

Constructor.

, 26.06.2018.

Parameters

  type | The type.
  numPoints | Number of points.
  outputDim | The output dim.

Definition at line 50 of file FgILayer.h.

## ◆ ~ILayer()

template<typename Scalar >

virtual NeuralEngine::MachineLearning::ILayer< Scalar >::~ILayer | ( |  | ) |
| virtual default

Destructor.

, 26.06.2018.

## ◆ ILayer() [2/2]

template<typename Scalar >

NeuralEngine::MachineLearning::ILayer< Scalar >::ILayer | ( |  | ) |
| inline protected

Default constructor.

, 26.06.2018.

Definition at line 124 of file FgILayer.h.

## Member Function Documentation

## ◆ GetType()

template<typename Scalar >

LayerType NeuralEngine::MachineLearning::ILayer< Scalar >::GetType | ( |  | ) |
| inline

Gets the layer type.

, 26.06.2018.

Returns
  The type.

Definition at line 67 of file FgILayer.h.

## ◆ GetNumParameters()

template<typename Scalar >

virtual int NeuralEngine::MachineLearning::ILayer< Scalar >::GetNumParameters | ( |  | ) |
| pure virtual

Gets number of parameters to be optimized.

, 26.06.2018.

Returns
  The number parameters.

Implemented in NeuralEngine::MachineLearning::GPModels::GaussEmission< Scalar >, NeuralEngine::MachineLearning::GPModels::GPBaseLayer< Scalar >, NeuralEngine::MachineLearning::GPModels::LikelihoodBaseLayer< Scalar >, NeuralEngine::MachineLearning::GPModels::GaussLikLayer< Scalar >, and NeuralEngine::MachineLearning::GPModels::SparseGPBaseLayer< Scalar >.

## ◆ SetParameters()

template<typename Scalar >

virtual void NeuralEngine::MachineLearning::ILayer< Scalar >::SetParameters | ( | const af::array & | param | ) |
| pure virtual

Sets the parameters for each optimization iteration.

, 26.06.2018.

Parameters

  param | The parameter.

Implemented in NeuralEngine::MachineLearning::GPModels::GaussEmission< Scalar >, NeuralEngine::MachineLearning::GPModels::GPBaseLayer< Scalar >, NeuralEngine::MachineLearning::GPModels::LikelihoodBaseLayer< Scalar >, NeuralEngine::MachineLearning::GPModels::GaussLikLayer< Scalar >, and NeuralEngine::MachineLearning::GPModels::SparseGPBaseLayer< Scalar >.

## ◆ GetParameters()

template<typename Scalar >

virtual af::array NeuralEngine::MachineLearning::ILayer< Scalar >::GetParameters | ( |  | ) |
| pure virtual

Gets the parameters for each optimization iteration.

, 26.06.2018.

Returns
  The parameters.

Implemented in NeuralEngine::MachineLearning::GPModels::GaussEmission< Scalar >, NeuralEngine::MachineLearning::GPModels::GPBaseLayer< Scalar >, NeuralEngine::MachineLearning::GPModels::LikelihoodBaseLayer< Scalar >, NeuralEngine::MachineLearning::GPModels::GaussLikLayer< Scalar >, and NeuralEngine::MachineLearning::GPModels::SparseGPBaseLayer< Scalar >.

## ◆ UpdateParameters()

template<typename Scalar >

virtual void NeuralEngine::MachineLearning::ILayer< Scalar >::UpdateParameters | ( |  | ) |
| pure virtual

Updates the parameters.

, 26.06.2018.

Implemented in NeuralEngine::MachineLearning::GPModels::GaussEmission< Scalar >, NeuralEngine::MachineLearning::GPModels::GPBaseLayer< Scalar >, NeuralEngine::MachineLearning::GPModels::LikelihoodBaseLayer< Scalar >, NeuralEngine::MachineLearning::GPModels::AEP::SGPLayer< Scalar >, NeuralEngine::MachineLearning::GPModels::GaussLikLayer< Scalar >, NeuralEngine::MachineLearning::GPModels::PowerEP::SGPLayer< Scalar >, NeuralEngine::MachineLearning::GPModels::PowerEP::SGPLayer2nd< Scalar >, and NeuralEngine::MachineLearning::GPModels::SparseGPBaseLayer< Scalar >.

## ◆ SetDataSize()

template<typename Scalar >

virtual void NeuralEngine::MachineLearning::ILayer< Scalar >::SetDataSize | ( | int | length,
|  | int | dimension
| ) |  |
| inline virtual

Sets data size.

Hmetal T, 03/09/2020.

Parameters

  length | The length.
  dimension | The dimension.

Reimplemented in NeuralEngine::MachineLearning::GPModels::GPBaseLayer< Scalar >.

Definition at line 111 of file FgILayer.h.

## ◆ serialize()

template<typename Scalar >
template<class Archive >

void NeuralEngine::MachineLearning::ILayer< Scalar >::serialize | ( | Archive & | ar,
|  | unsigned int | version
| ) |  |
| inline private

Definition at line 137 of file FgILayer.h.

## Friends And Related Function Documentation

## ◆ boost::serialization::access

template<typename Scalar >

friend class boost::serialization::access
| friend

Definition at line 134 of file FgILayer.h.

## Member Data Documentation

## ◆ iD

template<typename Scalar >

int NeuralEngine::MachineLearning::ILayer< Scalar >::iD
| protected

data dimension

Definition at line 126 of file FgILayer.h.

## ◆ iN

template<typename Scalar >

int NeuralEngine::MachineLearning::ILayer< Scalar >::iN
| protected

data size

Definition at line 127 of file FgILayer.h.

## ◆ lType

template<typename Scalar >

LayerType NeuralEngine::MachineLearning::ILayer< Scalar >::lType
| protected

liklihood or gp layer

Definition at line 129 of file FgILayer.h.

## ◆ m_dType

template<typename Scalar >

af::dtype NeuralEngine::MachineLearning::ILayer< Scalar >::m_dType
| protected

floating point precision flag for af::array

Definition at line 131 of file FgILayer.h.

The documentation for this class was generated from the following file:

- FgILayer.h